;#include	"msp430x14x.h"
;GAS help: see http://tigcc.ticalc.org/doc/gnuasm.html
;--------------------------------------
;load definitions for ASM from global file
;--------------------------------------
#define	_MSP430_ASM_
#include "global.h"
#include "adc.h"
;======================================
	.data
	.global	ADC_buf
	.global	FFT_buf
	.global	TMP_buf
	.global	ADC_int_stat
ADC_buf:
FFT_buf:
	.space	256
TMP_buf:
;;	.space	512	;space for FFT calculation too
	.space	256
ADC_int_stat:
	.space	2
;======================================
	.text
;======================================
; wait for trigger and sampling 128 samples
;--------------------------------------
#ifndef _ADC_INT_C_
;--------------------------------------
;local variables
#define	R_PTR	R4
#define	R_LOOP	R5
#define	R_STAT	R6
#define	R_TRIG	R7
#define	R_PRE	R8
#define	R_CNT	R9
#define	R_POS	R10
#define	R_VAL	R15
;--------------------------------------
	.global	__isr_7
__isr_7:
;;ADCi_interrupt:
	push	R_PTR
	push	R_LOOP
	push	R_STAT
	push	R_TRIG
	push	R_PRE
	push	R_CNT
	push	R_POS
	push	R_VAL
;load variables
	mov.w	&ADC_int_stat, R_STAT
	mov.w	&ADC_trigval, R_TRIG
	mov.w	&ADC_pre, R_PRE
	mov.w	&ADC_cnt, R_CNT
	mov.w	&ADC_pos, R_POS
	add.w	R_POS, R_POS
ADCi_retry:
	add.w	&ADC12IV, R0
	jmp	ADCi_end		;no interrupt pending
	jmp	ADCi_overflow
	jmp	ADCi_time_overflow
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_first
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_unexpected
	jmp	ADCi_second
;------
ADCi_end:
;store variables
	rra.w	R_POS
	mov.w	R_POS, &ADC_pos
	mov.w	R_CNT, &ADC_cnt
	mov.w	R_PRE, &ADC_pre
	mov.w	R_STAT, &ADC_int_stat
;restore registers
	pop	R_VAL
	pop	R_POS
	pop	R_CNT
	pop	R_PRE
	pop	R_TRIG
	pop	R_STAT
	pop	R_LOOP
	pop	R_PTR
	reti
;--------------------------------------
; error handling
;--------------------------------------
ADCi_overflow:
	bis.w	#ADC_ERR_OVER, &ADC_trigstat
	jmp	ADCi_stop
;------
ADCi_time_overflow:
	bis.w	#ADC_ERR_TIME, &ADC_trigstat
	jmp	ADCi_stop
;------
ADCi_unexpected:
	bis.w	#ADC_ERR_INT, &ADC_trigstat
;	jmp	ADCi_stop
ADCi_stop:
;	bic.w	#0x000C, &ADC12CTL0	;disable interrupts
;	bic.w	#0x000F, &ADC12CTL0	;disable conversion
;	jmp	ADC_int_end
	jmp	ADCi_retry
;--------------------------------------
; data processing
;--------------------------------------
ADCi_first:
	mov.w	#ADC12MEM0, R_PTR
	jmp	ADCi_common
;------
ADCi_second:
	mov.w	#ADC12MEM8, R_PTR
;;	jmp	ADCi_common
;------
ADCi_common:
	mov.b	#8, R_LOOP
ADCi_loop:
;nacteni vysledku
	mov.w	@R_PTR+, R_VAL
	tst.w	R_CNT
	jz	ADCi_loop_cont
;ulozeni vysledku
	mov.w	R_VAL, ADC_buf(R_POS)
	add.b	#2, R_POS
;provedeni pozadovane akce
	add.w	R_STAT, R0
;NORMAL rising edge
	jmp	ADCi_fill
	jmp	ADCi_pretrig_rise
	jmp	ADCi_trig_rise
	jmp	ADCi_posttrig_F
;NORMAL falling edge
	jmp	ADCi_fill
	jmp	ADCi_pretrig_fall
	jmp	ADCi_trig_fall
	jmp	ADCi_posttrig_F
;AUTO rising edge
	jmp	ADCi_fill
	jmp	ADCi_pretrig_rise_auto
	jmp	ADCi_trig_rise_auto
	jmp	ADCi_posttrig_F
;AUTO falling edge
	jmp	ADCi_fill
	jmp	ADCi_pretrig_fall_auto
	jmp	ADCi_trig_fall_auto
	jmp	ADCi_posttrig_F
;free run
	jmp	ADCi_fill
	jmp	ADCi_posttrig
;roll run
;	jmp	ADCi_roll
ADCi_roll:
	sub.b	#2, R_POS
	dec.w	R_PRE
	jnz	ADCi_loop_cont
	add.b	#2, R_POS
	mov.w	R_CNT, R_PRE
	jmp	ADCi_loop_cont
;------
ADCi_fill:
	tst.w	R_PRE
	jz	ADCi_no_fill
	dec.w	R_PRE
	jnz	ADCi_loop_cont
ADCi_no_fill:
	add	#2, R_STAT
ADCi_loop_cont:
	dec.w	R_LOOP
	jnz	ADCi_loop
	jmp	ADCi_retry
;------
ADCi_posttrig_F:
	bis.w	#ADC_TRIGGERED, &ADC_trigstat
ADCi_posttrig:
	dec.w	R_CNT
	dec.w	R_LOOP
	jnz	ADCi_loop
	jmp	ADCi_retry
;------
ADCi_pretrig_rise_auto:
	tst.b	R_POS
	jz	ADCi_auto_stop
ADCi_pretrig_rise:
	add.w	#TRIG_HYST, R_VAL
ADCi_trig_fall:
	cmp.w	R_TRIG, R_VAL
	jge	ADCi_loop_cont
	add.w	#2, R_STAT		;next trigger mode
	dec.w	R_LOOP
	jnz	ADCi_loop
	jmp	ADCi_retry
;------
ADCi_pretrig_fall_auto:
	tst.b	R_POS
	jz	ADCi_auto_stop
ADCi_pretrig_fall:
	add.w	#-TRIG_HYST, R_VAL
ADCi_trig_rise:
	cmp.w	R_TRIG, R_VAL
	jl	ADCi_loop_cont
	add.w	#2, R_STAT		;next trigger mode
	dec.w	R_LOOP
	jnz	ADCi_loop
	jmp	ADCi_retry
;------
ADCi_trig_rise_auto:
	tst.b	R_POS
	jnz	ADCi_trig_rise		;always 2 cycles
ADCi_auto_stop:
	mov.w	#0, R_CNT		;finish sampling
	dec.w	R_LOOP
	jnz	ADCi_loop
	jmp	ADCi_retry
;------
ADCi_trig_fall_auto:
	tst.b	R_POS
	jnz	ADCi_trig_fall
	mov.w	#0, R_CNT		;finish sampling
	dec.w	R_LOOP
	jnz	ADCi_loop
	jmp	ADCi_retry
;------
;disable ADC - end of sampling
ADCi_loop_dis:
	bic.w	#0x0006, &ADC12CTL1	;single conversion
	bic.w	#0x000F, &ADC12CTL0	;ENC = 0, overflow interrupts off
	mov.w	#0, &ADC12IE		;interrupts off
	bis.b	#0x80, &ADC12MCTL0	;EOS
	jmp	ADCi_retry
;--------------------------------------
;;	.section .vectors
;;	.org	ADC12_VECTOR
;;	.word	ADCi_interrupt
;;	.text
;--------------------------------------
;end of locals
#undef	R_PTR
#undef	R_LOOP
#undef	R_STAT
#undef	R_TRIG
#undef	R_PRE
#undef	R_CNT
#undef	R_POS
#undef	R_VAL
;
#endif
;======================================
; fast conversion 300kS/s ~ 21 cycles
;--------------------------------------
;void ADCsample (unsigned char channel, unsigned int post, unsigned int trigger);
; it is possible to take these values from global variables...
;R12-R15 -> parameters, not preserved
; R4-R11 -> locals, must be preserved!
;
;if I will solve various triggering, it is possible to use add.w R_case,PC
;--------------------------------------
;local variables
#define	R_PTR	R4
#define	R_IMASK	R5
#define	R_IPTR	R6
#define	R_TRIG	R7
#define	R_PRE	R8
#define	R_CNT	R9
#define	R_POS	R10
#define	R_ENC	R11
#define	R_MODE	R12
#define	R_VAL	R15
;--------------------------------------
	.global	ADC_sample
ADC_sample:
;save R4-R11
	push	R_PTR
	push	R_IMASK
	push	R_IPTR
	push	R_TRIG
	push	R_PRE
	push	R_CNT
	push	R_POS
	push	R_ENC
	push	R_MODE
	push	R_VAL
;prepare registers
	mov.w	#1, R_IMASK		;ADC12IFG0
	mov.w	#ADC12IFG, R_IPTR
	mov.w	#ADC12MEM0, R_PTR
	mov.w	#0, R_POS		;&ADC_pos
	mov.w	&ADC_pre, R_PRE
	mov.w	&ADC_trigval, R_TRIG
	mov.w	&ADC_cnt, R_CNT
	mov.w	#P2IFG, R_ENC
	mov.w	&ADC_int_stat, R_MODE
;------
;pretrigger bufferu length
	tst.w	R_PRE
	jz	ADC_mode_jump
;fill pretrigger buffer
ADC_loop_00:
;wait fo conversion sompletion
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_00		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
	dec.w	R_PRE			;1
	jnz	ADC_loop_00		;2
;------					;=15
;jump based on mode
ADC_mode_jump:
	add.w	R_MODE, R0		;2
	jmp	ADC_normal_rise		;2
	nop
	nop
	nop
	jmp	ADC_normal_fall
	nop
	nop
	nop
	jmp	ADC_auto_rise
	nop
	nop
	nop
	jmp	ADC_auto_fall
	nop
	nop
	nop
	jmp	ADC_posttrig		;free
;------
ADC_normal_rise:
	add.w	#-TRIG_HYST, R_TRIG	;2
;wait for trigger
ADC_loop_10:
;wait for conversion completion
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_10		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
;check control buttons
	tst.b	@R_ENC			;1/2?
	jnz	ADC_enc_exit		;2
	cmp.w	R_TRIG, R_VAL		;1
	jge	ADC_loop_10		;2;R_TRIG < R_VAL
;------					;=18
	add.w	#TRIG_HYST, R_TRIG	;2
ADC_loop_20:
;wait for conversion completion
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_20		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
;check control buttons
	tst.b	@R_ENC			;1/2?
	jnz	ADC_enc_exit		;2
	cmp.w	R_TRIG, R_VAL		;1
	jl	ADC_loop_20		;2;R_TRIG >= R_VAL
;------					;=18
	jmp	ADC_posttrig
;------
ADC_normal_fall:
	add.w	#TRIG_HYST, R_TRIG	;2
;wait for trigger
ADC_loop_11:
;wait for conversion end
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_11		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
;check control buttons
	tst.b	@R_ENC			;1/2?
	jnz	ADC_enc_exit		;2
	cmp.w	R_TRIG, R_VAL		;1
	jl	ADC_loop_11		;2;R_TRIG < R_VAL
;------					;=18
	add.w	#-TRIG_HYST, R_TRIG	;2
ADC_loop_21:
;wait for conversion end
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_21		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
;check control buttons
	tst.b	@R_ENC			;1/2?
	jnz	ADC_enc_exit		;2
	cmp.w	R_TRIG, R_VAL		;1
	jge	ADC_loop_21		;2;R_TRIG >= R_VAL
;------					;=18
	jmp	ADC_posttrig
;------
ADC_auto_rise:
	add.w	#-TRIG_HYST, R_TRIG	;2
;wait for trigger
ADC_loop_12:
;wait for conversion end
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_12		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
	jz	ADC_A_exit		;2
;check control buttons
	tst.b	@R_ENC			;1/2?
	jnz	ADC_enc_exit		;2
	cmp.w	R_TRIG, R_VAL		;1
	jge	ADC_loop_12		;2;R_TRIG < R_VAL
;------					;=20
	add.w	#TRIG_HYST, R_TRIG	;2
ADC_loop_22:
;wait for conversion end
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_22		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
	jz	ADC_A_exit		;2
;check control buttons
	tst.b	@R_ENC			;1/2?
	jnz	ADC_enc_exit		;2
	cmp.w	R_TRIG, R_VAL		;1
	jl	ADC_loop_22		;2;R_TRIG >= R_VAL
;------					;=20
	jmp	ADC_posttrig
;------
ADC_auto_fall:
	add.w	#TRIG_HYST, R_TRIG	;2
;wait for trigger
ADC_loop_13:
;wait for conversion end
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_13		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
	jz	ADC_A_exit		;2
;check control buttons
	tst.b	@R_ENC			;1/2?
	jnz	ADC_enc_exit		;2
	cmp.w	R_TRIG, R_VAL		;1
	jl	ADC_loop_13		;2;R_TRIG < R_VAL
;------					;=20
	add.w	#-TRIG_HYST, R_TRIG	;2
ADC_loop_23:
;wait for conversion end
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_23		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
	jz	ADC_A_exit		;2
;check control buttons
	tst.b	@R_ENC			;1/2?
	jnz	ADC_enc_exit		;2
	cmp.w	R_TRIG, R_VAL		;1
	jge	ADC_loop_23		;2;R_TRIG >= R_VAL
;------					;=20
;;	jmp	ADC_posttrig
;------
ADC_posttrig:
;fill posttrigger buffer
ADC_loop_30:
;wait for conversion end
	bit.w	@R_IPTR, R_IMASK	;2
	jz	ADC_loop_30		;2
;value is always in ADC12MEM0
	mov.w	@R_PTR, R_VAL		;2
;store ADC value to memory
	mov.w	R_VAL, ADC_buf(R_POS)	;5
	add.b	#2, R_POS		;1/2?
;fill posttrigger buffer
	dec.w	R_CNT			;1/2?
	jnz	ADC_loop_30		;2
;------					;=15
	bis.w	#ADC_TRIGGERED, &ADC_trigstat
;save variables
ADC_exit:
	mov.w	R_CNT, &ADC_cnt
	rra.w	R_POS
	mov.w	R_POS, &ADC_pos
;restore registers
	pop	R_VAL
	pop	R_MODE
	pop	R_ENC
	pop	R_POS
	pop	R_CNT
	pop	R_PRE
	pop	R_TRIG
	pop	R_IPTR
	pop	R_IMASK
	pop	R_PTR
;	
	ret
;
ADC_enc_exit:
	bis.w	#ADC_BUF_PART, &ADC_trigstat
	jmp	ADC_exit
;
ADC_A_exit:
	mov	#0, R_CNT
	jmp	ADC_exit
;--------------------------------------
#undef	R_PTR
#undef	R_IMASK
#undef	R_IPTR
#undef	R_TRIG
#undef	R_PRE
#undef	R_CNT
#undef	R_POS
#undef	R_MODE
#undef	R_VAL
;======================================
	.global	ADC_get
;void ADC_get (int *buf);
ADC_get:
	mov.w	#128, R14
	mov.b	&ADC_pos, R13
	add.b	R13, R13
ADC_get_loop:
	mov.w	ADC_buf(R13), R12
	add.b	#2, R13
	mov.w	R12, @R15
	add.w	#2, R15
	dec.w	R14
	jnz	ADC_get_loop
;
	ret
;======================================
;void ADC_convert (unsigned char *buf, unsigned int *sample, unsigned int mul);
;*buf = R15
;*sample = R14
;mul = R13
;;_ADC_convert::
;;	mov.w	#128, R12
;;	push	R11
;;ADC_con_loop:
;;	mov.w	@R14+, R11
;;	sub.w	#ADC_OFFSET, R11
;======================================
	.global	ADC_convert
;unsigned int ADC_convert (unsigned int sample, unsigned int multiply); // multiplication only...
ADC_convert:
	mov.w	R15, &MPY
	mov.w	R14, &OP2
	mov.w	&RESHI, R15
	ret
;======================================
