/*************************************************************
 * Pocket oscilloscope; (c) 2009 Hynek Sladky                *
 *                                                           *
 * lcd.h                                                     *
 *************************************************************/
#ifndef _LCD_H_
#define _LCD_H_
#include "fontdef.h"
// ====================================
// data structures
// ------------------------------------
typedef struct {
  unsigned char row, col, ofs;
  unsigned char usedRow;
  unsigned char xor, or;
  FontInfo curr_font;
} LCDstateType;
// ====================================
// function prototypes
// ------------------------------------
// generic
void LCDdelay (unsigned time);
// low-level
void LCDbyte (unsigned char data);
void LCDcmd (unsigned char cmd);
void LCDcmd2 (unsigned char cmd, unsigned char data);
void LCDdata (unsigned char line, unsigned char col);
void LCDend (void);
//
void LCD_init (void);
// conio + stdout
void LCDclearRow (unsigned char row);
void LCDpos (unsigned char co_, unsigned char ro_);
void LCDclear (void);
void LCDbufw (const unsigned char *buf, unsigned char len, unsigned char step);
void LCDfill (char data, unsigned char to_x);
void LCDmode (unsigned char x_mask, unsigned char o_mask);
const FontType *SetFont (const FontType *fnt);
int DrawOneChar (unsigned char c);
void DrawChars (unsigned char x, unsigned char y, const unsigned char *s);
int __putchar (int c);

int CharWidth (unsigned char c);
int StrWidth (char *s);

#endif
